<?php

namespace Slovocast\Domain;

use DateTime;
use DateTimeImmutable;

trait Record
{
    protected ?DateTimeImmutable $createdAt;
    protected ?DateTime $updatedAt;

    public function setCreatedAt(DateTimeImmutable|string $createdAt): void
    {
        if (is_string($createdAt)) {
            $this->createdAt = new DateTimeImmutable($createdAt);
        } else {
            $this->createdAt = $createdAt;
        }
    }

    public function getCreatedAt(): DateTimeImmutable
    {
        return $this->createdAt;
    }

    public function setUpdatedAt(DateTime|string $updatedAt): void
    {
        if (is_string($updatedAt)) {
            $this->updatedAt = new DateTime($updatedAt);
        } else {
            $this->updatedAt = $updatedAt;
        }
    }

    public function getUpdatedAt(): DateTime
    {
        return $this->updatedAt;
    }

    public function markUpdated(): void
    {
        $this->updatedAt = new DateTime();
    }

    public function markCreated(): void
    {
        $this->createdAt = new DateTimeImmutable();
        $this->updatedAt = new DateTime();
    }
}
