<?php

namespace Slovocast\Handler;

use Psr\Http\Message\ResponseInterface;
use Slovocast\Handler\Handler;

abstract class AsyncHandler extends Handler
{
    /**
     * @param array<mixed> $data Data used for the response
     */
    public function prepareResponse(array $data, string $template = ""): ResponseInterface 
    {
        $acceptsHeaders = $this->request->getHeader('Accept');

        if (in_array('text/html', $acceptsHeaders)) {
            return $this->renderInline($template, $data);
        }

        return $this->json($data);
    }
}
