<?php

namespace Slovocast\Handler;

use Psr\Http\Message\ResponseInterface;
use Slovocast\Exception\TemplateNotSetException;

/**
 * Ideally, this class will be used for static pages that do no require any
 * specific or special functionality to render them. Something like Home
 * Pages.
 */
abstract class Page extends Handler
{
    protected string $template = '';
    protected array $pageProps = [];

    /**
     * @throws TemplateNotSetException
     */
    public function handle(): ResponseInterface
    {
        if (!$this->template) {
            throw new TemplateNotSetException("No template set.");
        }

        return $this->render($this->template, $this->pageProps);
    }
}
